package Create;

use strict;
use English;
use ConfigSubs;

use vars qw/@ISA/;

@ISA=qw(ConfigPatch);

sub new {
  my ($type, @rest) = @_;
  my($class) = ref($type) || $type || "Create";

  my $this = $class->SUPER::new();
  bless $this, $class;

  if(@_ >= 2) {
    $this->readSubst($_[1]);
  }

  return $this;
}

sub readSubst {
  my ($this, $file) = @_;
  $this->{file} = $file;
}

# Do the substitutions
sub doSubst {
  my ($this, $target) = @_;

  ConfigSubs::init();
  my $file = $this->{file};
  $target = ConfigSubs::replaceVars($target);

  if(-f $target) {
    return;
  }

  open(IN, "<$file") || die "Could not read $file ($ERRNO)\n";
  open(OUT, ">$target") || die "Could not write $target ($ERRNO)\n";
  while(<IN>) {
    my $line = $_;

    if($line =~ /^@@%/) {
      # Skip intro line
      next;
    }
    $line = ConfigSubs::replaceVars($line);
    print OUT $line;
  }
  chmod 0644, $target;
  close(IN);
  close(OUT);
}

1;
